# Contributing to Haystack

We are very open to community contributions and appreciate anything that improves `haystack`! This includes fixings typos, adding missing documentation, fixing bugs or adding new features.
To avoid unnecessary work on either side, please stick to the following process:

1. Check if there is already [an related issue](https://github.com/deepset-ai/haystack/issues).
2. If there is not, open a new one to start a discussion. Some features might be a nice idea, but don't fit in the scope of Haystack and we hate to close finished PRs!
3. If we came to the conclusion to move forward with your issue, we will be happy to accept a pull request. Make sure you create a pull request in an early draft version and ask for feedback. 
4. Verify that all tests in the CI pass (and add new ones if you implement anything new)

## Formatting of Pull Requests

Please give a concise description in the first comment in the PR that includes: 
- What is changing?
- Why? 
- What are limitations?
- Breaking changes (Example of before vs. after)
- Link the issue that this relates to
